//  pushsdk.h
//

#import <Foundation/Foundation.h>

typedef enum {
    kTCPushErrorNone = 0,
    kTCPushErrorSystemFail,
    kTCPushErrorNetworkFail,
    kTCPushErrorServerFail,
    kTCPushErrorAlreadyInProgress,
    kTCPushErrorInvalidParameters,
} TCPushErrors;

extern NSString *const kTCPushKeyServerUrl;
extern NSString *const kTCPushKeyPushType;
extern NSString *const kTCPushKeyAgreeNotification;
extern NSString *const kTCPushKeyAgreeAd;
extern NSString *const kTCPushKeyAgreeNightAd;
extern NSString *const kTCPushKeyChannel;
extern NSString *const kTCPushKeyCountry;
extern NSString *const kTCPushKeyLanguage;
extern NSString *const kTCPushKeyTimeout;

extern NSString *const kTCPushTypeAPNS;
extern NSString *const kTCPushTypeAPNS_SANDBOX;

typedef void (^OnRegister)(int error);

typedef void (^OnQuery)(int error, NSDictionary *options);

@interface TCPushSdk : NSObject

+ (int)registerWithAppKey:(NSString *)appKey userId:(NSString *)userId onRegister:(OnRegister)onRegister options:(NSDictionary *)options;

+ (int)queryForAppKey:(NSString *)appKey userId:(NSString *)userId onQuery:(OnQuery)onQuery options:(NSDictionary *)options;

+ (NSString *)sdkVersion;

@end


__IOS_AVAILABLE(10.0)
@interface TCPushAnalytics : NSObject

+ (void)onReceivedNotificationWithUrl:(NSString *)serverUrl appKey:(NSString *)appKey userInfo:(NSDictionary *)userInfo completionHandler:(void (^)())handler;

+ (void)onOpenedNotificationWithUrl:(NSString *)serverUrl appKey:(NSString *)appKey userInfo:(NSDictionary *)userInfo completionHandler:(void (^)())handler;

@end

